#!/usr/bin/perl

#use strict;
use Carp;
use IO::Socket;
use POSIX;

use Tk;

sub update_title;
sub update_volume;
use vars qw($pass $warc $title $n_bytes);

@cmds = qw(prev play pause stop next);


if (scalar(@ARGV) != 3) {
    print "usage: $0 server port password\n";
    exit;
}

$pass = $ARGV[2];
$0 = 'winampRC -- linux tcp client []';

$warc = IO::Socket::INET->new(
			      PeerAddr => $ARGV[0],
			      PeerPort => $ARGV[1],
			      Proto => 'tcp',
			      Reuse => 1,
			      Timeout => 2
			     );
# set non-blocking
fcntl($warc, F_SETFL(), O_NONBLOCK());

# build Tk interface
$top = MainWindow->new;
$label = $top->Label(
		     -relief => 'raised',
		     -textvariable => \$title,
		     )->pack(-side => "top");
$canvas = $top->Canvas(-height => 12, -width => 110, -background => 'black');

$map = $top->Pixmap('bob', -file => "warc.xpm");
$cimage = $canvas->createImage(55,5, -image => $map);
$canvas->pack(-side => "top");
$canvas->addtag('bob', "all");
$canvas->bind('bob', "<ButtonPress>" => [\&send_command, Ev("%x"), Ev("%y")]);
$frame = $top->Frame()->pack(-side => "top");
$flab = $frame->Label(-text => 'Vol')->pack(-side => "left");
$fscale = $frame->Scale(-orient => 'horizontal',
			-from => 0,
			-to => 255,
			-showvalue => 'no',
			-variable => \$volume,
			-command => \&update_volume,
			)->pack(-side => "left");

$volume = 128; # set it in the middle
update_title;

$top->after(5000, \&update_title);
MainLoop;

sub update_title {
    my $cmd = $pass."\tgetplaylisttitle\t\n";
#    print "$cmd";
    print $warc "$cmd";
    sleep(1);
    $n_bytes = sysread $warc, $title_before, 1024;
    $title = substr($title_before, 6, length($title_before) - 6);
    $top->after(5000, \&update_title);
}

sub send_command {
    my ($this, $x, $y) = @_;
    
    my $cmd_idx = $x / 22;
    my $cmd = $pass."\t".$cmds[$cmd_idx]."\t\n";
    print $warc "$cmd";
}

sub update_volume {
    my $cmd = $pass."\tVolume $volume\t\n";
#    print "$cmd";
    print $warc "$cmd";
}
